<?php

namespace App\Models;

use App\Entities\Loja\Loja;

// use const False\MyClass\true;
class LojaModel extends ModelEntity {
	protected $table = 'loja';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [
			'id_unidade',
			'id_status', 
			'descricao',
			'criado_por',
			'data_criacao',
			'hora_criacao',
			'alterado_por',	
			'data_alteracao', 
			'hora_alteracao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;

	public function registerLoja(Loja $tipoExtorno): void {

		$id_new_tipo_extorno = $this->insert( $tipoExtorno->toArray( true ) );
		$tipoExtorno->setId( $id_new_tipo_extorno );

	}

	public function updateLojaByID(int $id_tipo_extorno, Loja $tipo_extorno): bool {

		$data = $tipo_extorno->toArray( true );
		$binds = [ 
				'id_loja' => $id_tipo_extorno
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "UPDATE loja $sets WHERE loja.id = :id_loja:";
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
